package test;


import java.awt.Frame;
import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.MouseListener ;
import java.awt.event.MouseEvent ;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javabullet.BulletGlobals;
import javabullet.BulletStack;
import javabullet.collision.broadphase.BroadphaseInterface;
import javabullet.collision.broadphase.SimpleBroadphase;
import javabullet.collision.dispatch.CollisionDispatcher;
import javabullet.collision.dispatch.CollisionObject;
import javabullet.collision.dispatch.DefaultCollisionConfiguration;
import javabullet.collision.shapes.BoxShape;
import javabullet.collision.shapes.CollisionShape;
import javabullet.collision.shapes.StaticPlaneShape;
import javabullet.demos.opengl.GLShapeDrawer;
import javabullet.dynamics.DiscreteDynamicsWorld;
import javabullet.dynamics.DynamicsWorld;
import javabullet.dynamics.RigidBody;
import javabullet.dynamics.RigidBodyConstructionInfo;
import javabullet.dynamics.constraintsolver.ConstraintSolver;
import javabullet.dynamics.constraintsolver.SequentialImpulseConstraintSolver;
import javabullet.dynamics.constraintsolver.TypedConstraint;
import javabullet.linearmath.Clock;
import javabullet.linearmath.DefaultMotionState;
import javabullet.linearmath.Transform;

import javax.media.Buffer;
import javax.media.opengl.GL;
import javax.media.opengl.glu.*;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLEventListener;
//import javax.vecmath.Color3f;
import javax.vecmath.Quat4f;
import javax.vecmath.Vector3f;

import com.sun.opengl.util.Animator;

import jp.nyatla.nyartoolkit.core.NyARCode;
import jp.nyatla.nyartoolkit.jmf.utils.JmfCameraCapture;
import jp.nyatla.nyartoolkit.jmf.utils.JmfCaptureListener;
import jp.nyatla.nyartoolkit.jogl.utils.GLNyARParam;
import jp.nyatla.nyartoolkit.jogl.utils.GLNyARRaster_RGB;
import jp.nyatla.nyartoolkit.jogl.utils.GLNyARSingleDetectMarker;
import jp.nyatla.nyartoolkit.jogl.utils.NyARGLUtil;
import kGLModel.KGLCoordinates_ARToolKit;
import kGLModel.KGLException;
import kGLModel.KGLExtensionCheck;
import kGLModel.KGLLight;
import kGLModel.KGLModelData;
import kGLModel.KGLShadowMapping;

public class TestJBullet implements GLEventListener,MouseListener, JmfCaptureListener {
	/**
	 * MQOt@Cǂݍ񂾃f\邩ǂ
	 */
	private boolean modelDisplay = true ;
	/**
	 * e邩ǂ
	 */
	private boolean shadowDisplay = true ;
//	private String filename = "../sachi2/rin-ren.mqo" ; // kei add
//	private String filename = "../sachi2/miku_pose.mqo" ; // kei add
//	private String filename = "../sachi2/box2.mqo" ; // kei add
	private String filename = "../Data/arrow.mqo" ; // kei add
	private KGLModelData model = null ; // kei add
	private RigidBody modelBody = null ;
	private int	modelStatus = 0 ;
	KGLShadowMapping sm = null ; // kei add
	KGLLight light = null ; // kei add
	private final String CARCODE_FILE ="../Data/patt.hiro"; // kei add
	private final String CARCODE_FILE2 ="../Data/patt.kanji"; // kei add
	private final String PARAM_FILE   ="../Data/camera_para.dat"; // kei add
//    private final String CARCODE_FILE ="../../Data/patt.hiro";
//    private final String PARAM_FILE   ="../../Data/camera_para.dat";
       
    private int SCREEN_X=320;
    private int SCREEN_Y=240;
    private Animator animator;
    private GLNyARRaster_RGB cap_image;
    
    private JmfCameraCapture capture;
    private GL  gl;
    private NyARGLUtil glnya;
    


    //NyARToolkit֌W
    private GLNyARSingleDetectMarker nya_grand;
    private GLNyARSingleDetectMarker nya;
    private GLNyARParam ar_param;

    private double[] grand_projection = null ;
    private double[] grand_modelview = null ;
    private final int	   model_aliveframes = 5 ;
    private int	   model_aliveframe = 0 ;
    private double[] save_modelview = null ;
    //JBullet֌W
    private JOGLGL igl ;
    private float box_size = 0.2f ;
    Vector3f testPos = null ;

	protected final BulletStack stack = BulletStack.get();
	
//	private static final float STEPSIZE = 5;
	
	public static int numObjects = 0;
	public static final int maxNumObjects = 16384;
	public static Transform[] startTransforms = new Transform[maxNumObjects];
	public static CollisionShape[] gShapePtr = new CollisionShape[maxNumObjects]; //1 rigidbody has 1 shape (no re-use of shapes)
	
	public static RigidBody pickedBody = null; // for deactivation state
	
	static {
		for (int i=0; i<startTransforms.length; i++) {
			startTransforms[i] = new Transform();
		}
	}
	// TODO: class CProfileIterator* m_profileIterator;
	
	// JAVA NOTE: added
//	protected IGL gl;

	protected Clock clock = new Clock();

	// this is the most important class
	protected DynamicsWorld dynamicsWorld = null;

	// constraint for mouse picking
	protected TypedConstraint pickConstraint = null;

	protected CollisionShape shootBoxShape = null;
	protected CollisionShape testBoxShape = null;
	protected RigidBody	testRigiBody = null ;
	// create 125 (5x5x5) dynamic object
	private static final int ARRAY_SIZE_X = 5;
	private static final int ARRAY_SIZE_Y = 5;
	private static final int ARRAY_SIZE_Z = 5;

	// maximum number of objects (and allow user to shoot additional boxes)
	private static final int MAX_PROXIES = (ARRAY_SIZE_X*ARRAY_SIZE_Y*ARRAY_SIZE_Z + 1024);

	private static  float START_POS_X = -3f;
	private static  float START_POS_Y = -3f;
	private static  float START_POS_Z = 1f;
//	private static final int START_POS_Y = -5;
//	private static final int START_POS_Z = -3;
	
	// keep the collision shapes, for deletion/cleanup
	private List<CollisionShape> collisionShapes = new ArrayList<CollisionShape>();
	private BroadphaseInterface overlappingPairCache;
	private CollisionDispatcher dispatcher;
	private ConstraintSolver solver;
	private DefaultCollisionConfiguration collisionConfiguration;
	protected float ShootBoxInitialSpeed = 40f;
	protected final Vector3f cameraUp = new Vector3f(0f, 0f, 1f);

	/**
	 * javabullet.demo.opengl.DemoApplication甲oEҏW
	 * @return
	 */
	public DynamicsWorld getDynamicsWorld() {
		return dynamicsWorld;
	}
	/**
	 * javabullet.demo.basic.BasicDemo甲oEҏW
	 * clientResetScene()̃\bhɓWJ
	 * @param model
	 */
	public void initPhysics(KGLModelData model) {
//		setCameraDistance(50f);

		// collision configuration contains default setup for memory, collision setup
		collisionConfiguration = new DefaultCollisionConfiguration();

		// use the default collision dispatcher. For parallel processing you can use a diffent dispatcher (see Extras/BulletMultiThreaded)
		dispatcher = new CollisionDispatcher(collisionConfiguration);

		// the maximum size of the collision world. Make sure objects stay within these boundaries
		// TODO: AxisSweep3
		// Don't make the world AABB size too large, it will harm simulation quality and performance
//		Vector3f worldAabbMin = new Vector3f(-10000,-10000,-10000);
//		Vector3f worldAabbMax = new Vector3f(10000,10000,10000);
		//overlappingPairCache = new AxisSweep3(worldAabbMin,worldAabbMax,MAX_PROXIES);
		overlappingPairCache = new SimpleBroadphase(MAX_PROXIES);
		//overlappingPairCache = new _BrutalforceBroadphase();

		// the default constraint solver. For parallel processing you can use a different solver (see Extras/BulletMultiThreaded)
		SequentialImpulseConstraintSolver sol = new SequentialImpulseConstraintSolver();
		solver = sol;
		
		// TODO: needed for SimpleDynamicsWorld
		//sol.setSolverMode(sol.getSolverMode() & ~SolverMode.SOLVER_CACHE_FRIENDLY.getMask());
		
		dynamicsWorld = new DiscreteDynamicsWorld(dispatcher, overlappingPairCache, solver, collisionConfiguration);
		//dynamicsWorld = new SimpleDynamicsWorld(dispatcher, overlappingPairCache, solver, collisionConfiguration);

//		dynamicsWorld.setGravity(new Vector3f(0f, -10f, 0f));
		dynamicsWorld.setGravity(new Vector3f(0f, 0f, -9.8f));

		// create a few basic rigid bodies
		//CollisionShape groundShape = new BoxShape(new Vector3f(50f, 50f, 50f));
		CollisionShape groundShape = new StaticPlaneShape(new Vector3f(0, 0, 1), 0);
//		CollisionShape groundShape = new StaticPlaneShape(new Vector3f(0, 1, 0), 50);

		collisionShapes.add(groundShape);

		Transform groundTransform = new Transform();
		groundTransform.setIdentity();
		groundTransform.origin.set(0, 0, 0);
//		groundTransform.origin.set(0, -56, 0);

		// We can also use DemoApplication::localCreateRigidBody, but for clarity it is provided here:
		{
			float mass = 0f;

			// rigidbody is dynamic if and only if mass is non zero, otherwise static
			boolean isDynamic = (mass != 0f);

			Vector3f localInertia = new Vector3f(0, 0, 0);
			if (isDynamic) {
				groundShape.calculateLocalInertia(mass, localInertia);
			}

			// using motionstate is recommended, it provides interpolation capabilities, and only synchronizes 'active' objects
			DefaultMotionState myMotionState = new DefaultMotionState(groundTransform);
			RigidBodyConstructionInfo rbInfo = new RigidBodyConstructionInfo(mass, myMotionState, groundShape, localInertia);
			RigidBody body = new RigidBody(rbInfo);

			// add the body to the dynamics world
			dynamicsWorld.addRigidBody(body);
		}

		if( model == null ){	//MQOt@CǂݍłȂׂ͔
			// create a few dynamic rigidbodies
			// Re-using the same collision is better for memory usage and performance

			CollisionShape colShape = new BoxShape(new Vector3f(box_size, box_size, box_size));
			//CollisionShape colShape = new SphereShape(1f);
			collisionShapes.add(colShape);

			// Create Dynamic Objects
			Transform startTransform = new Transform();
			startTransform.setIdentity();

			float mass = 1;

			// rigidbody is dynamic if and only if mass is non zero, otherwise static
			boolean isDynamic = (mass != 0f);

			Vector3f localInertia = new Vector3f(0, 0, 0);
			if (isDynamic) {
				colShape.calculateLocalInertia(mass, localInertia);
			}

			float start_x = (START_POS_X - ARRAY_SIZE_X / 2)*box_size;
			float start_y = (START_POS_Y- ARRAY_SIZE_Y / 2)*box_size;
			float start_z = (START_POS_Z)*box_size ;
//			float start_y = START_POS_Y;
//			float start_z = START_POS_Z - ARRAY_SIZE_Z / 2;

			for (int k = 0; k < ARRAY_SIZE_Y; k++) {
				for (int i = 0; i < ARRAY_SIZE_X; i++) {
					for (int j = 0; j < ARRAY_SIZE_Z; j++) {
						startTransform.origin.set(
								box_size * 2 * i + start_x,
								box_size * 2 * k + start_y,
								box_size * 2 * j + start_z);

						// using motionstate is recommended, it provides interpolation capabilities, and only synchronizes 'active' objects
						DefaultMotionState myMotionState = new DefaultMotionState(startTransform);
						RigidBodyConstructionInfo rbInfo = new RigidBodyConstructionInfo(mass, myMotionState, colShape, localInertia);
						RigidBody body = new RigidBody(rbInfo);

						dynamicsWorld.addRigidBody(body);
					}
				}
			}
		}
		else {//MQOt@Cǂݍł鎞́Aǂݍ񂾃f̍ŏlAőlՓ˔{bNX쐬B
			float box_x = model.getMaxPos().X() - model.getMinPos().X() ;
			float box_y = model.getMaxPos().Y() - model.getMinPos().Y() ;
			float box_z = model.getMaxPos().Z() - model.getMinPos().Z() ;
			CollisionShape colShape = new BoxShape(new Vector3f(box_x/2, box_y/2, box_z/2));
			//CollisionShape colShape = new SphereShape(1f);
			collisionShapes.add(colShape);

			// Create Dynamic Objects
			Transform startTransform = new Transform();
			startTransform.setIdentity();
			startTransform.origin.set(
					model.getMinPos().X()+box_x/2,
					model.getMinPos().Y()+box_y/2,
					model.getMinPos().Z()+box_z/2
					) ;

			float mass = 100;

			// rigidbody is dynamic if and only if mass is non zero, otherwise static
			boolean isDynamic = (mass != 0f);

			Vector3f localInertia = new Vector3f(0, 0, 0);
			if (isDynamic) {
				colShape.calculateLocalInertia(mass, localInertia);
			}
			DefaultMotionState myMotionState = new DefaultMotionState(startTransform);
			RigidBodyConstructionInfo rbInfo = new RigidBodyConstructionInfo(mass, myMotionState, colShape, localInertia);
			RigidBody body = new RigidBody(rbInfo);

			dynamicsWorld.addRigidBody(body);
			modelBody = body ;
		}
		
		
		//clientResetScene()WJ

		//#ifdef SHOW_NUM_DEEP_PENETRATIONS
		BulletGlobals.gNumDeepPenetrationChecks = 0;
		BulletGlobals.gNumGjkChecks = 0;
		//#endif //SHOW_NUM_DEEP_PENETRATIONS

		int numObjects = 0;
		if (dynamicsWorld != null) {
			dynamicsWorld.stepSimulation(1f / 60f, 0);
			numObjects = dynamicsWorld.getNumCollisionObjects();
		}

		for (int i = 0; i < numObjects; i++) {
			CollisionObject colObj = dynamicsWorld.getCollisionObjectArray().get(i);
			RigidBody body = RigidBody.upcast(colObj);
			if (body != null) {
				if (body.getMotionState() != null) {
					DefaultMotionState myMotionState = (DefaultMotionState) body.getMotionState();
					myMotionState.graphicsWorldTrans.set(myMotionState.startWorldTrans);
					colObj.setWorldTransform(myMotionState.graphicsWorldTrans);
					colObj.setInterpolationWorldTransform(myMotionState.startWorldTrans);
					colObj.activate();
				}
				// removed cached contact points
				dynamicsWorld.getBroadphase().getOverlappingPairCache().cleanProxyFromPairs(colObj.getBroadphaseHandle(), getDynamicsWorld().getDispatcher());

				body = RigidBody.upcast(colObj);
				if (body != null && !body.isStaticObject()) {
					RigidBody.upcast(colObj).setLinearVelocity(new Vector3f(0f, 0f, 0f));
					RigidBody.upcast(colObj).setAngularVelocity(new Vector3f(0f, 0f, 0f));
				}
			}

			/*
			//quickly search some issue at a certain simulation frame, pressing space to reset
			int fixed=18;
			for (int i=0;i<fixed;i++)
			{
			getDynamicsWorld()->stepSimulation(1./60.f,1);
			}
			*/
		}
	}
	private final Transform m = new Transform();
	private Vector3f wireColor = new Vector3f();
//	private Color3f TEXT_COLOR = new Color3f(0f, 0f, 0f);
//	private StringBuilder buf = new StringBuilder();

	/**
	 * javabullet.demo.opengl.DemoApplication甲oEҏW<br>
	 * Z̃V~[VʂOpenGLŕ`悷
	 */
	public void renderme(boolean isTestValid) {
//		updateCamera();
		{ // ȏ`iepj
			gl.glEnable(GL.GL_ALPHA_TEST) ;
			gl.glEnable(GL.GL_BLEND) ;
			gl.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_ONE_MINUS_SRC_ALPHA) ;
			gl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
			float[] fw = new float[4] ;
			float floorsize = 100 ;
			fw[0] = fw[1] = fw[2] = fw[3] = 0.0f;
			fw[3] = 0.0f ;
		    gl.glColor4f(0.0f,0.0f,0.0f,0.0f) ;
		    gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_DIFFUSE,fw,0) ;
			fw[0] = fw[1] = fw[2] = fw[3] = 0.0f;
			fw[3] = 0.0f ;
		    gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_AMBIENT,fw,0) ;
		    gl.glNormal3i(0,0,1) ;
		    gl.glBegin(GL.GL_QUADS) ;
		    	gl.glVertex3f(-1.0f*floorsize,-1.0f*floorsize,0) ;
		    	gl.glVertex3f(-1.0f*floorsize, 1.0f*floorsize,0) ;
		    	gl.glVertex3f( 1.0f*floorsize, 1.0f*floorsize,0) ;
		    	gl.glVertex3f( 1.0f*floorsize,-1.0f*floorsize,0) ;
			gl.glEnd() ;
		}

		if (dynamicsWorld != null) {
			int numObjects = dynamicsWorld.getNumCollisionObjects();
			wireColor.set(1f, 0f, 0f);
			for (int i = 0; i < numObjects; i++) {
				CollisionObject colObj = dynamicsWorld.getCollisionObjectArray().get(i);
				RigidBody body = RigidBody.upcast(colObj);
//				ꂶ\ȂǁAdynamicsWorldtestRigiBodyƂExceptionłBBB
				if( (!isTestValid) && body == testRigiBody ) {
					continue ;
				}

				if (body != null && body.getMotionState() != null) {
					DefaultMotionState myMotionState = (DefaultMotionState) body.getMotionState();
					m.set(myMotionState.graphicsWorldTrans);
				}
				else {
					m.set(colObj.getWorldTransform());
				}

				wireColor.set(1f, 1f, 0.5f); // wants deactivation
				if ((i & 1) != 0) {
					wireColor.set(0f, 0f, 1f);
				}

				// color differently for active, sleeping, wantsdeactivation states
				if (colObj.getActivationState() == 1) // active
				{
					if ((i & 1) != 0) {
						//wireColor.add(new Vector3f(1f, 0f, 0f));
						wireColor.x += 1f;
					}
					else {
						//wireColor.add(new Vector3f(0.5f, 0f, 0f));
						wireColor.x += 0.5f;
					}
				}
				if (colObj.getActivationState() == 2) // ISLAND_SLEEPING
				{
					if ((i & 1) != 0) {
						//wireColor.add(new Vector3f(0f, 1f, 0f));
						wireColor.y += 1f;
					}
					else {
						//wireColor.add(new Vector3f(0f, 0.5f, 0f));
						wireColor.y += 0.5f;
					}
				}
				if( modelBody == body ) {//ǂݍ񂾃^ZRf̕`
					if( modelStatus != modelBody.getActivationState() ) {
						modelStatus = modelBody.getActivationState() ;
//						System.out.println("model status = "+modelStatus) ;
					}
					float[] mtx = new float[16] ;
					gl.glPushMatrix();
						m.getOpenGLMatrix(mtx) ;
						gl.glMultMatrixf(mtx,0);
						float box_z = model.getMaxPos().Z() - model.getMinPos().Z() ;
						gl.glTranslatef(0,0,-(box_z/2)) ;
						gl.glEnable(GL.GL_CULL_FACE) ;
						gl.glCullFace(GL.GL_BACK) ;
						model.enables(1.0f) ;
						model.draw() ;
						model.disables() ;
						gl.glDisable(GL.GL_CULL_FACE) ;
					gl.glPopMatrix() ;
				}
				else {
					GLShapeDrawer.drawOpenGL(igl, m, colObj.getCollisionShape(), wireColor, 0);
				}
			}

//			float  = 10f;
//			float yStart = 20f;
//			float yIncr = 20f;

//			gl.glDisable(GL_LIGHTING);
			gl.glColor3f(0f, 0f, 0f);
		}
	}
	/* */
	protected final Vector3f cameraPosition = new Vector3f(0f, 0f, 0f);
	protected final Vector3f cameraTargetPosition = new Vector3f(0f, 0f, 0f); // look at
	public void setCameraPosition(double[] pos) {
		cameraPosition.set((float)pos[0],(float)pos[1],(float)pos[2]) ;
	}
	public Vector3f getCameraPosition() {
		return cameraPosition;
	}

	public void setCameraTargetPosition(double[] pos) {
		cameraTargetPosition.set((float)pos[0],(float)pos[1],(float)pos[2]) ;
	}
	public Vector3f getCameraTargetPosition() {
		return cameraTargetPosition;
	}
	/**
	 * javabullet.demo.opengl.DemoApplication甲oEҏW
	 */
	public void shootBox(Vector3f destination) {
		if (dynamicsWorld != null) {
			float mass = 10;
			Transform startTransform = new Transform();
			startTransform.setIdentity();
			Vector3f camPos = new Vector3f(getCameraPosition());
			startTransform.origin.set(camPos);

			if (shootBoxShape == null) {
				//#define TEST_UNIFORM_SCALING_SHAPE 1
				//#ifdef TEST_UNIFORM_SCALING_SHAPE
				//btConvexShape* childShape = new btBoxShape(btVector3(1.f,1.f,1.f));
				//m_shootBoxShape = new btUniformScalingShape(childShape,0.5f);
				//#else
				shootBoxShape = new BoxShape(new Vector3f(box_size, box_size, box_size));
				//#endif//
			}

			RigidBody body = this.localCreateRigidBody(mass, startTransform, shootBoxShape,(mass!=0));

			Vector3f linVel = new Vector3f(destination.x - camPos.x, destination.y - camPos.y, destination.z - camPos.z);
			linVel.normalize();
			linVel.scale(ShootBoxInitialSpeed*box_size);

			body.getWorldTransform().origin.set(camPos);
			body.getWorldTransform().setRotation(new Quat4f(0f, 0f, 0f, 1f));
			body.setLinearVelocity(linVel);
			body.setAngularVelocity(new Vector3f(0f, 0f, 0f));
		}
	}
	/**
	 * javabullet.demo.opengl.DemoApplication甲oEҏW
	 */
	public Vector3f getRayTo(int x, int y) {
		float top = 1f;
		float bottom = -1f;
		float nearPlane = 1f;
		float tanFov = (top - bottom) * 0.5f / nearPlane;
		float fov = 2f * (float) Math.atan(tanFov);

		Vector3f rayFrom = new Vector3f(getCameraPosition());
		Vector3f rayForward = new Vector3f();
		rayForward.sub(getCameraTargetPosition(), getCameraPosition());
		rayForward.normalize();
		float farPlane = 600f;
		rayForward.scale(farPlane);

//		Vector3f rightOffset = new Vector3f();
		Vector3f vertical = new Vector3f(cameraUp);

		Vector3f hor = new Vector3f();
		// TODO: check: hor = rayForward.cross(vertical);
		hor.cross(rayForward, vertical);
		hor.normalize();
		// TODO: check: vertical = hor.cross(rayForward);
		vertical.cross(hor, rayForward);
		vertical.normalize();

		float tanfov = (float) Math.tan(0.5f * fov);
		hor.scale(2f * farPlane * tanfov);
		vertical.scale(2f * farPlane * tanfov);
		Vector3f rayToCenter = new Vector3f();
		rayToCenter.add(rayFrom, rayForward);
		Vector3f dHor = new Vector3f(hor);
		dHor.scale(1f / (float) SCREEN_X);
		Vector3f dVert = new Vector3f(vertical);
		dVert.scale(1.f / (float) SCREEN_Y);

		Vector3f tmp1 = new Vector3f();
		Vector3f tmp2 = new Vector3f();
		tmp1.scale(0.5f, hor);
		tmp2.scale(0.5f, vertical);

		Vector3f rayTo = new Vector3f();
		rayTo.sub(rayToCenter, tmp1);
		rayTo.add(tmp2);

		tmp1.scale(x, dHor);
		tmp2.scale(y, dVert);

		rayTo.add(tmp1);
		rayTo.sub(tmp2);
		return rayTo;
	}
	/**
	 * javabullet.demo.opengl.DemoApplication甲oEҏW
	 */
	public RigidBody localCreateRigidBody(float mass, Transform startTransform, CollisionShape shape,boolean isDynamic) {
		// rigidbody is dynamic if and only if mass is non zero, otherwise static
//		boolean isDynamic = (mass != 0f);

		Vector3f localInertia = new Vector3f(0f, 0f, 0f);
		if (isDynamic) {
			shape.calculateLocalInertia(mass, localInertia);
		}

		// using motionstate is recommended, it provides interpolation capabilities, and only synchronizes 'active' objects

		//#define USE_MOTIONSTATE 1
		//#ifdef USE_MOTIONSTATE
		DefaultMotionState myMotionState = new DefaultMotionState(startTransform);
		RigidBody body = new RigidBody(new RigidBodyConstructionInfo(mass, myMotionState, shape, localInertia));
		//#else
		//btRigidBody* body = new btRigidBody(mass,0,shape,localInertia);	
		//body->setWorldTransform(startTransform);
		//#endif//
		dynamicsWorld.addRigidBody(body);

		return body;
	}


    public TestJBullet()
    {
        Frame frame = new Frame("Java simpleLite with NyARToolkit");


        // 3D`悷R|[lg
        GLCanvas canvas = new GLCanvas();
        frame.add(canvas);
        canvas.addGLEventListener(this);
        canvas.addMouseListener(this) ;
        frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });

        frame.setVisible(true);
        Insets ins=frame.getInsets();
        frame.setSize(SCREEN_X+ins.left+ins.right,SCREEN_Y+ins.top+ins.bottom);
        canvas.setBounds(ins.left,ins.top,SCREEN_X,SCREEN_Y);
    }

    public void init(GLAutoDrawable drawable) {
		// TODO ꂽ\bhEX^u
        gl = drawable.getGL();
        gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
//      -------v------ MQOǂݍ
        try {// kei add
            if( modelDisplay ) {
	        	model = KGLModelData.createGLModel(gl,null,new File(filename),0.015f,
	        			new KGLCoordinates_ARToolKit(),true,
	        			KGLExtensionCheck.IsExtensionSupported(gl,"GL_ARB_vertex_buffer_object")) ;
	        	System.out.println(model.toString()) ;
	        	System.out.println("ŏl  "+model.getMinPos().X()+", "+model.getMinPos().Y()+", "+model.getMinPos().Z()) ;
	        	System.out.println("ől  "+model.getMaxPos().X()+", "+model.getMaxPos().Y()+", "+model.getMaxPos().Z()) ;
            }
            if( shadowDisplay ) {
	        	try {
	        		sm = new KGLShadowMapping(gl,new GLU()) ;
	        		light = new KGLLight(gl,GL.GL_LIGHT0,4.0f,-5.0f,8.0f,0.8f,0.8f,0.8f) ;
	        		
	        		sm.init(light,0,1,2048,2048,0.5f,false) ;//Ōboolean true͂܂ŃfobOp
	//        		sm = null ;
	//        		sm.init(light,0,1,320,240,0.5f,true) ;//Ōboolean true͂܂ŃfobOp
	        	}
	        	catch(KGLException ke) {
	        		System.out.print(ke.getMessage()) ;
	        		sm = null ;
	        		ke.printStackTrace() ;
	        	}
	        	catch(Exception e) {
	        		e.printStackTrace() ;
	        	}
            }
		}catch(Exception e){
			e.printStackTrace();
		}
//      -----^^^------
        //JBullet
        igl = new JOGLGL(gl,new GLU()) ;
        initPhysics(model) ;
        //NyARToolkit̏
        try{
            //Lv`̏
            capture=new JmfCameraCapture(SCREEN_X,SCREEN_Y,15f,JmfCameraCapture.PIXEL_FORMAT_RGB);
            capture.setCaptureListener(this);
            //NyARToolkit̏
            ar_param=new GLNyARParam();
            NyARCode ar_code  =new NyARCode(16,16);
            NyARCode ar_code_g  =new NyARCode(16,16);
            ar_param.loadFromARFile(PARAM_FILE);
            ar_param.changeSize(SCREEN_X,SCREEN_Y);
            ar_code.loadFromARFile(CARCODE_FILE2);
            ar_code_g.loadFromARFile(CARCODE_FILE);
            nya=new GLNyARSingleDetectMarker(ar_param,ar_code,80.0);
            nya_grand = new GLNyARSingleDetectMarker(ar_param,ar_code_g,80.0);
            //NyARToolkitp̎xNX
            glnya=new NyARGLUtil(gl,ar_param);
            //GLΉRGBX^IuWFNg
            cap_image=new GLNyARRaster_RGB(gl,ar_param);
            //Lv`Jn
            capture.start();
        }catch(Exception e){
            e.printStackTrace();
        }
        animator = new Animator(drawable);

        animator.start();

	}

	public void display(GLAutoDrawable arg0) {
		// TODO ꂽ\bhEX^u
		boolean modelvalid  = false ;

        try{
            if(!cap_image.hasData()){
        	return;
            }    
            gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT); // Clear the buffers for new frame.          
            //摜`FbNă}[J[TāAwi
            boolean is_marker_exist_grand;
            boolean is_marker_exist;
            double chk_grand ;
            double chk ;
            synchronized(cap_image){
            	try {
            		is_marker_exist_grand=nya_grand.detectMarkerLite(cap_image,100);
            	}
            	catch(Exception e) {
            		is_marker_exist_grand = false ;
            	}
            	try {
            		is_marker_exist=nya.detectMarkerLite(cap_image,100);
            	}
            	catch(Exception e) {
            		is_marker_exist = false ;
            	}
        	//wi
        	glnya.drawBackGround(cap_image, 1.0);
            }
            //nʐݒ悤}[J̃`FbN
            chk_grand = nya_grand.getConfidence() ;
            chk = nya.getConfidence() ;
            if(is_marker_exist_grand && 0.6 < chk_grand){
                grand_projection = ar_param.getCameraFrustumRH() ;
                grand_modelview = nya_grand.getCameraViewRH() ;
            }
            if(grand_projection != null ) {
            	
        	//}[J[̈vx𒲍Ȃ΁Anya.getConfidence()ňvx𒲂ׂĉB
                // Projection transformation.
                gl.glMatrixMode(GL.GL_PROJECTION);
//                gl.glLoadMatrixd(ar_param.getCameraFrustumRH(),0);
                gl.glLoadMatrixd(grand_projection,0);
                gl.glMatrixMode(GL.GL_MODELVIEW);
                // Viewing transformation.
                gl.glLoadIdentity();
//                gl.glLoadMatrixd(nya_grand.getCameraViewRH(),0);
                gl.glLoadMatrixd(grand_modelview,0);

                double[][] mat = new double[3][4] ;
                double[][] inv = new double[3][4] ;
                double[] q = new double[4] ;
                double[] p = new double[3] ;
                double[] cammat = new double[16] ;
                cammat = grand_modelview ;
                KarUtil.argConvArpara(cammat,mat) ;
                KarUtil.arUtilMatInv(mat,inv) ;
//				KarUtil.arUtilMatInv(nya.getTransmationMatrix().getArray(),inv) ;
                KarUtil.arUtilMat2QuatPos(inv,q,p) ;
//                p[0] *= 10 ;
//                p[1] *= 10 ;
//                p[2] *= 10 ;
                setCameraPosition(p) ;
                if(is_marker_exist && 0.6 < chk){
                	save_modelview = nya.getCameraViewRH() ;
                	model_aliveframe = 0 ;
                }
                else {
                	if( model_aliveframe < model_aliveframes ) model_aliveframe++ ;
                	else save_modelview = null ;
                }
                if( save_modelview != null ) {
                	modelvalid = true ;
                	//NyARMat.getCameraViewRH()̒ňʒuɂODOQTH|Ă̂ŁA
                	//ꂩ}gbNXČvZȂƕςɂȂH
//                	NyARMat armat = nya.getTransmationMatrix() ;
//                	armat.matrixSelfInv() ;
                	double[][] warmat = new double[3][4] ;
                	cammat = save_modelview ;
                	KarUtil.argConvArpara(cammat,warmat) ;
                	double[][] gmat = new double[4][4] ;
                	double[][] tmat = new double[4][4] ;
                	double[][] newmat = new double[4][4] ;
                	double[] glmat = new double[16] ; 
                	float[] fglmat = new float[16] ; 
                	for( int i = 0 ; i < 3 ; i++ ) {
                		for(int j = 0 ; j < 4 ; j++ ) {
                			gmat[i][j] = inv[i][j] ;
                			tmat[i][j] = warmat[i][j] ;
                		}
                	}
                	gmat[3][0] = gmat[3][1] = gmat[3][2] = 0 ;
                	tmat[3][0] = tmat[3][1] = tmat[3][2] = 0 ;
                	gmat[3][3] = tmat[3][3] = 1 ;
                	KarUtil.arMatrixMul(newmat,gmat,tmat) ;
                	KarUtil.arUtilMat2QuatPos(newmat,q,p) ;
        			Transform startTransform = new Transform();
        			startTransform.setIdentity();
//        			Vector3f Pos = new Vector3f((float)p[0],(float)p[1],(float)p[2]);
 //       			startTransform.origin.set(Pos);
        			KarUtil.argConvGlpara(glmat,newmat) ;
        			for( int i = 0 ; i < fglmat.length ; i++ ) fglmat[i] = (float)glmat[i] ;
        			startTransform.setFromOpenGLMatrix(fglmat) ;
//        			startTransform.setRotation(new Quat4f((float)q[0],(float)q[1],(float)q[2],(float)q[3])) ;
        			if( testBoxShape == null ) {
//	        			testBoxShape = new BoxShape(new Vector3f(box_size, box_size, box_size)) ;
	        			testBoxShape = new BoxShape(new Vector3f(1.5f, 1.5f, 0.1f)) ;
	        			testRigiBody = this.localCreateRigidBody(100, startTransform,testBoxShape ,true);
        				testRigiBody.setGravity(new Vector3f(0,0,0f)) ;
        				testRigiBody.getWorldTransform().setRotation(new Quat4f(0f, 0f, 0f, 1f));
        				testRigiBody.setAngularVelocity(new Vector3f(0f, 0f, 0f));
//        				float fff = testRigiBody.getAngularFactor() ;
//        				testRigiBody.setAngularFactor(10) ;
//        				fff = testRigiBody.getHitFraction() ;
//        				testRigiBody.setHitFraction(0.1f) ;
//        				fff = testRigiBody.getFriction() ;
//        				testRigiBody.setFriction(0.1f) ;
        			}
        			else {
//        				if( ! validTestRigiBody ) {
//        					dynamicsWorld.addRigidBody(testRigiBody) ;
//        				}
        				testRigiBody.getWorldTransform().setFromOpenGLMatrix(fglmat) ;
        				if( testRigiBody.getActivationState() == CollisionObject.ISLAND_SLEEPING ) {
        					testRigiBody.setActivationState(CollisionObject.ACTIVE_TAG) ;
        				}
        			}
                }
                else {
 					if( testRigiBody != null ) {
						testRigiBody.setActivationState(CollisionObject.ISLAND_SLEEPING) ;
					}
                }
                
        		// simple dynamics world doesn't handle fixed-time-stepping
        		float ms = clock.getTimeMicroseconds();
        		clock.reset();
        		// step the simulation
        		if (dynamicsWorld != null) {
        			dynamicsWorld.stepSimulation(ms / 1000000f);
        			// optional but useful: debug drawing
        			dynamicsWorld.debugDrawWorld();
        		}
        		gl.glEnable(GL.GL_DEPTH_TEST) ;
        		if( sm == null ) {
        			renderme(modelvalid) ;
        		}
        		else {
	        		//shadow map 쐬
	                sm.beforeMakeShadowMap(0,0,0,  50,2,  0,0,1) ;
	                gl.glPushMatrix() ;
	                renderme(modelvalid) ;
	                gl.glPopMatrix() ;
	                sm.afterMakeShadowMap();
	                gl.glDisable(GL.GL_CULL_FACE);
	                synchronized(cap_image){
	            	//wi
	            	glnya.drawBackGround(cap_image, 1.0);
	                }
	                sm.beforeDrowSiene() ;
	                renderme(modelvalid) ;
	                sm.afterDrowSiene() ;
        		}
            }
	    }catch(Exception e){
	        e.printStackTrace();
	    }
	}

	public void reshape(GLAutoDrawable arg0, int arg1, int arg2, int width,
			int height) {
		// TODO ꂽ\bhEX^u
        gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
        gl.glViewport(0, 0,  width, height);
        SCREEN_X = width ;
        SCREEN_Y = height ;

        //̐ς̐ݒ
        gl.glMatrixMode(GL.GL_PROJECTION);
        gl.glLoadIdentity();
        //ʒu
        gl.glMatrixMode(GL.GL_MODELVIEW);
        gl.glLoadIdentity();
        if( sm != null ) sm.init_tex_shadowmap() ; // kei add
	}

	public void displayChanged(GLAutoDrawable arg0, boolean arg1, boolean arg2) {
		// TODO ꂽ\bhEX^u

	}

	public void onUpdateBuffer(Buffer i_buffer) {
		// TODO ꂽ\bhEX^u
		try{
		    synchronized(cap_image){
			cap_image.setBuffer(i_buffer, true);
		    }
		}catch(Exception e){
		    e.printStackTrace();
		}        

	}
	
	public void mouseClicked(MouseEvent e)  {
		
	}
	public void mouseEntered(MouseEvent e)  {
		
	}
	public void mouseExited(MouseEvent e)  {
		
	}
	public void mousePressed(MouseEvent e)  {
		Vector3f rayTo = new Vector3f(getRayTo(e.getX(), e.getY()));
		shootBox(rayTo);
	}
	public void mouseReleased(MouseEvent e)  {
		
	}

	/* */
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO ꂽ\bhEX^u
        new TestJBullet();

	}

}
