package kGLModel;

import javax.media.opengl.GL;
import java.nio.*;


/**
 * Framebuffer Objectׂ̃NX<br>
 * hCoŃT|[gĂȂƎgȂiGL_EXT_framebuffer_objectj<br>
 * <br>
 * gp@<br>
 * setup()ŏݒ<br>
 * <br>
 * use_start()łeanւ̏݊Jn<br>
 * use_end()łeanւ̏ݏIit[obt@ʏ`p֖߂j<br>
 * @author kei
 *
 */
public class KGLfbo {
	/**
	 * OpenGLR}hQJvZNX
	 * (JOGL)
	 */
	protected GL gl;

	/**
	 * eanŊmۂĂeNX`̕
	 */
	protected int width ;
	/**
	 * eanŊmۂĂeNX`̍
	 */
	protected int hight ;
	/**
	 * eanԍ
	 */
	private int[] id = null ;
//	int render_id ;
	/**
	 * FeNX`
	 */
	private int[] tex_rgba = null;
	/**
	 * [xeNX`
	 */
	private int[] tex_depth = null;
	/**
	 * [x݂̂ǂ̃tO
	 */
	private boolean isDepthOnly = false ;
	

	/**
	 * RXgN^
	 * @param in_gl	OpenGLR}hQJvZNX
	 * @throws KGLException	eanhCoŃT|[gĂȂ
	 */
	public KGLfbo(GL in_gl) throws KGLException {
		//eanT|[g`FbN
		if( ! KGLExtensionCheck.IsExtensionSupported(in_gl,"GL_EXT_framebuffer_object") ) {
			throw new KGLException("framebuffer_object is not supported") ;
		}
		gl = in_gl ;
		width = -1 ;
		hight = -1 ;
	}
	/**
	 * eañZbgAbv<be>
	 * @param in_width		mۂ摜̕
	 * @param in_hight		mۂ摜̍
	 * @param isDepthOnly	[xobt@̂ݎgp邩ǂ
	 */
	public void setup(int in_width,int in_hight,boolean isDepthOnly) {
		if( id != null ) clear() ;
		this.isDepthOnly = isDepthOnly ;
		width = in_width ;
		hight = in_hight ;
		id = new int[1] ;
		//ean쐬
		gl.glGenFramebuffersEXT( 1, id,0 );
		gl.glBindFramebufferEXT( GL.GL_FRAMEBUFFER_EXT, id[0] );
		//Fobt@̍쐬
//		if( ! isDepthOnly ) {  obt@݂̂łRȂƂ܂Ȃ
			make_rgba() ;
			if( tex_rgba != null ) {
				gl.glFramebufferTexture2DEXT( GL.GL_FRAMEBUFFER_EXT, GL.GL_COLOR_ATTACHMENT0_EXT,
						GL.GL_TEXTURE_2D, tex_rgba[0], 0 );
			}
//		}
		//[xobt@쐬
		make_depth() ;
		if( tex_depth != null ) {
			gl.glFramebufferTexture2DEXT( GL.GL_FRAMEBUFFER_EXT, GL.GL_DEPTH_ATTACHMENT_EXT,
					GL.GL_TEXTURE_2D, tex_depth[0], 0 );
		}
		if( isDepthOnly ) {
			//[xobt@݂̂̏ꍇAF̕`~߂
			gl.glDrawBuffer( GL.GL_NONE );
			gl.glReadBuffer( GL.GL_NONE );
		}
		//t[obt@ɖ߂
		use_end() ;
	}
	/**
	 * t[obt@֕`Jn
	 *
	 */
	public void use_start() {
		//t[obt@̎gp錾
		if( tex_rgba != null ) {
			gl.glBindFramebufferEXT( GL.GL_FRAMEBUFFER_EXT,id[0]) ;
//			System.out.println("status = "+gl.glCheckFramebufferStatusEXT( GL.GL_FRAMEBUFFER_EXT )) ;
//			System.out.println("status = "+GL.GL_FRAMEBUFFER_COMPLETE_EXT) ;
		}
	}
	/**
	 * t[obt@ւ̕`I
	 *
	 */
	public void use_end() {
		//t[obt@ɖ߂
		gl.glBindFramebufferEXT( GL.GL_FRAMEBUFFER_EXT, 0 );
//		gl.glBindRenderbufferEXT(GL.GL_RENDERBUFFER_EXT, 0);

	}
	/**
	 * OpenGLɊmۂĂeԍ폜
	 *
	 */
	public void clear()   {
		try {
			//activete framebuffer
			if( id  != null ) {
				gl.glBindFramebufferEXT( GL.GL_FRAMEBUFFER_EXT, id[0] );
				//detach texture
				gl.glFramebufferTexture2DEXT( GL.GL_FRAMEBUFFER_EXT, GL.GL_COLOR_ATTACHMENT0_EXT,
						GL.GL_TEXTURE_2D, 0, 0 );
				gl.glFramebufferTexture2DEXT( GL.GL_FRAMEBUFFER_EXT, GL.GL_DEPTH_ATTACHMENT_EXT,
						GL.GL_TEXTURE_2D, 0, 0 );
				//deactivatte framebuffer
				gl.glBindFramebufferEXT( GL.GL_FRAMEBUFFER_EXT, 0 );
				gl.glBindRenderbufferEXT(GL.GL_RENDERBUFFER_EXT, 0);
			}
			//delete framebuffer
			if( id  != null ) gl.glDeleteFramebuffersEXT( 1, id,0 );
	//		if( fbos->render_id  != 0 ) gl.glDeleteRenderbuffersEXT( 1, &fbos->render_id );
			//delete texture
			if( tex_rgba != null ) gl.glDeleteTextures( 1, tex_rgba,0 );
			if( tex_depth != null ) gl.glDeleteTextures( 1, tex_depth,0 );
		}
		catch(Exception e) {
//			e.printStackTrace() ;
		}
		finally {
			id = null ;
			tex_rgba = null ;
			tex_depth = null ;
			width = -1 ;
			hight = -1 ;
		}
	}
	/**
	 * J[obt@̍쐬
	 *
	 */
	private void make_rgba() {
		tex_rgba = new int[1] ;
		gl.glEnable(GL.GL_TEXTURE_2D);
		gl.glGenTextures( 1, tex_rgba,0 );
		gl.glBindTexture( GL.GL_TEXTURE_2D, tex_rgba[0] );
		gl.glPixelStorei(GL.GL_UNPACK_ALIGNMENT,1);
		gl.glPixelStorei(GL.GL_PACK_ALIGNMENT,1);
//		glPixelStorei(GL_PACK_LSB_FIRST,GL_TRUE);
//		glPixelStorei(GL_PACK_SWAP_BYTES,GL_FALSE);
		gl.glTexImage2D( GL.GL_TEXTURE_2D, 0, GL.GL_RGBA, 
				width, hight, 0, 
				GL.GL_RGBA, GL.GL_UNSIGNED_BYTE, (Buffer)null );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_CLAMP );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_CLAMP );
		gl.glBindTexture(GL.GL_TEXTURE_2D,0) ;
		gl.glDisable(GL.GL_TEXTURE_2D);
	}
	/**
	 * [xobt@̍쐬
	 *
	 */
	private void make_depth() {
		tex_depth = new int[1] ;
		gl.glEnable(GL.GL_TEXTURE_2D);
		gl.glGenTextures( 1, tex_depth,0 );
		gl.glBindTexture( GL.GL_TEXTURE_2D, tex_depth[0] );
		gl.glTexImage2D( GL.GL_TEXTURE_2D, 0, GL.GL_DEPTH_COMPONENT,
				width, hight, 0,
				GL.GL_DEPTH_COMPONENT, GL.GL_UNSIGNED_BYTE, (Buffer)null );
		gl.glPixelStorei(GL.GL_UNPACK_ALIGNMENT,1);
		gl.glPixelStorei(GL.GL_PACK_ALIGNMENT,1);
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_CLAMP_TO_EDGE );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_CLAMP_TO_EDGE );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_COMPARE_MODE, GL.GL_COMPARE_R_TO_TEXTURE );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_COMPARE_FUNC, GL.GL_LEQUAL );
		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_DEPTH_TEXTURE_MODE, GL.GL_LUMINANCE );

		gl.glBindTexture(GL.GL_TEXTURE_2D,0) ;
		gl.glDisable(GL.GL_TEXTURE_2D);
	}
	/**
	 * OpenGLɓo^ĂJ[obt@̃eNX`ԍo
	 * @return	[xeNX`
	 */
	public int getTextureRGBA() {
		if( isDepthOnly ) return 0 ;
		if( tex_rgba == null ) return 0 ;
		return tex_rgba[0];
	}
	/**
	 * OpenGLɓo^Ă[xobt@̃eNX`ԍo
	 * @return	[xeNX`
	 */
	public int getTextureDepth() {
		if( tex_depth == null ) return 0 ;
		return tex_depth[0];
	}
}
