package test;
/*
 * {ARToolKit甲o֐Q
 */
public class KarUtil {
	/**
	 * gsub.c->argConvGlpara̋t
	 * @param gpara
	 * @param arpara
	 */
	public static void argConvArpara(double[] gpara,double[][] arpara) {
//		arpara = new double[3][4] ;
		for( int j = 0 ; j < 3 ; j++ ) {
			for( int i = 0 ; i < 4 ; i++ ) {
				arpara[j][i] = gpara[i*4+j] ;
			}
		}
	}
	public static void argConvGlpara(double[] gpara,double[][] arpara) {
//		arpara = new double[3][4] ;
		for( int j = 0 ; j < arpara.length ; j++ ) {
			for( int i = 0 ; i < arpara[j].length ; i++ ) {
				gpara[i*4+j] = arpara[j][i];
			}
		}
		if( arpara.length == 3 ) {
			gpara[3] = 0 ;
			gpara[7] = 0 ;
			gpara[11] = 0 ;
			gpara[15] = 1 ;
		}
	}
	public static int arMatrixMul(double[][] dest,double[][] a,double[][] b)
	{
		int r, c, i;
		double w ;

		if(a[0].length != b.length || dest.length != a.length || dest[0].length != b[0].length) return -1;

		for(r = 0; r < dest.length; r++) {
			for(c = 0; c < dest[r].length; c++) {
				w = 0.0 ; //ARELEM0(dest, r, c) = 0.0;
				for(i = 0; i < a[0].length; i++){
				    w+=a[r][i]*b[i][c];//ARELEM0(dest, r, c) += ARELEM0(a, r, i) * ARELEM0(b, i, c);
				}
				dest[r][c]=w;
			}
		}

		return 0;
	}	
	public static int arUtilMatInv(double[][] source,double[][] dest) throws Exception {
		double[][] m = new double[4][4] ;
//		dest = new double[source.length][source[0].length] ;
		for( int j = 0 ; j < m.length ; j++ ) {
			for( int i = 0 ; i < m[j].length ; i++ ) {
				if( j < source.length ) {
					m[j][i] = source[j][i] ;
				}
				else {
					if( i == (m[j].length-1) ) m[j][i] = 1 ;
					else m[j][i] = 0 ;
				}
			}
		}
		matrixSelfInv(m) ;
		for( int j = 0 ; j < dest.length ; j++ ) {
			for( int i = 0 ; i < dest[j].length ; i++ ) {
				dest[j][i] = m[j][i] ;
			}
		}
		return 0 ;
	}
	public static int arUtilMat2QuatPos(double[][] m ,double[] q, double[] p) {
	    double   w;

	    w = m[0][0] + m[1][1] + m[2][2] + 1;
	    if( w < 0.0 ) return -1;

	    w = Math.sqrt( w );
	    q[0] = (m[1][2] - m[2][1]) / (w*2.0);
	    q[1] = (m[2][0] - m[0][2]) / (w*2.0);
	    q[2] = (m[0][1] - m[1][0]) / (w*2.0);
	    q[3] = w / 2.0;

	    p[0] = m[0][3];
	    p[1] = m[1][3];
	    p[2] = m[2][3];

		return 0 ;
	}
    //NyARMat̎g悭킩Ȃ̂ŁAvZoB
    public static void matrixSelfInv(double[][] m) throws Exception
    {
	double[][] ap=m;
	int dimen=m.length;
	int dimen_1=dimen-1;
	double[] ap_n,ap_ip,ap_i;//wap;
	int j,ip,nwork;
	int[] nos=new int[50];//̊֐ŏB
	//double epsl;
	double p,pbuf,work;

//	epsl = 1.0e-10;         /* Threshold value      */
	/* check size */
	switch(dimen){
	case 0:
	    throw new Exception();
	case 1:
	    ap[0][0]=1.0/ap[0][0];//*ap = 1.0 / (*ap);
	    return;/* 1 dimension */
	}

        for(int n = 0; n < dimen ; n++){
            nos[n] = n;
        }

        /* nyatla memo
         * ip܂ȂŌvZsꍇ̂ő}B
         * [v0ĂȂB
         */
       	ip=0;
//       	int wap_ptr,wbp_ptr;
	//ForύX֎~
        for(int n=0; n<dimen;n++)
        {
            ap_n =ap[n];//wcp = ap + n * rowa;
            p=0.0;
//            wap_ptr=0;//wap = DoublePointer.wrap(wcp);
            for(int i = n; i<dimen ; i++){//for(i = n, wap = wcp, p = 0.0; i < dimen ; i++, wap += rowa)
//        	wap=ap[i];
        	if( p < ( pbuf = Math.abs(ap[i][0]))) {
        	    p = pbuf;
        	    ip = i;
        	}
            }
            if (p <= (1.0e-10)){
                return;
            }

            nwork  = nos[ip];
            nos[ip]= nos[n];
            nos[n] = nwork;
            
            ap_ip=ap[ip];
//            wbp=ap_n;
//            wap_ptr=0;
//            wbp_ptr=0;
            for(j=0; j< dimen ; j++){//for(j = 0, wap = ap + ip * rowa, wbp = wcp; j < dimen ; j++) {
            	work = ap_ip[j];               //work = *wap;
            	ap_ip[j]=ap_n[j];
//            	wap_ptr++;//*wap++ = *wbp;
            	ap_n[j]=work;
//                wbp_ptr++;     //*wbp++ = work;
            }
            
//            wap=ap_n;
//            wap_ptr=0;
            work=ap_n[0];
            for(j = 0; j < dimen_1 ; j++){//for(j = 1, wap = wcp, work = *wcp; j < dimen ; j++, wap++)
        	ap_n[j]=ap_n[j+1]/work;//*wap = *(wap + 1) / work;
//            	wap_ptr++;
            }
            ap_n[j]=1.0/work;//*wap = 1.0 / work;
//            wbp=ap_n;
            for(int i = 0; i < dimen ; i++) {
                if(i != n) {
                    ap_i =ap[i];//wap = ap + i * rowa;

//                    wap_ptr=0;
//                    wbp_ptr=0;
                    work=ap_i[0];
                    for(j = 0;j < dimen_1 ; j++){//for(j = 1, wbp = wcp, work = *wap;j < dimen ; j++, wap++, wbp++)
                	ap_i[j]=ap_i[j+1]-work*ap_n[j];//wap = *(wap + 1) - work * (*wbp);
//                        wap_ptr++;
//                        wbp_ptr++;
                    }
                    ap_i[j]=-work*ap_n[j];//*wap = -work * (*wbp);
                }
            }
        }

        for(int n = 0; n < dimen ; n++) {
            for(j = n; j < dimen ; j++){
        	if( nos[j] == n){
        	    break;
        	}
            }
            nos[j] = nos[n];
            for(int i = 0; i < dimen ;i++){//for(i = 0, wap = ap + j, wbp = ap + n; i < dimen ;i++, wap += rowa, wbp += rowa) {
        	ap_i=ap[i];
//        	wbp=ap[i];
                work  =ap_i[j];//work = *wap;
                ap_i[j]=ap_i[n];//*wap = *wbp;
                ap_i[n]=work;//*wbp = work;
	    }
        }
        return;
    }

}
