package test;
import java.awt.*;
import java.awt.event.*;

import javax.media.opengl.*;
import javax.media.opengl.glu.*;

import java.io.* ;
import java.nio.* ;
import java.net.*;
import java.util.*;

import kGLModel.* ;

public class Test extends Frame implements GLEventListener {
//	private float scale = 0.8f ;
	private float scale = 2.0f ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\arrow.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\sachi2.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\test.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\sachipng.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\miku_pose.mqo" ;
//	private String urlname = "http://dbsv/3d/sachi2/miku_pose.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\rin-ren.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\miku.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\miku0.mqo" ;
//	private String urlname = "http://dbsv/3d/sachi2/miku0.mqo" ;
//	private String filename = "D:\\3D\\javaMQO\\sachi2\\rin.mqo" ;
	private String filename = "../Data/arrow.mqo" ; // kei add

  private GL gl;             // glR}hQJvZNX
  private GLU glu ;
  KGLShadowMapping sm = null ;
  int fbow = 2048 ;//FBÕTCYe̐x
  int fboh = 2048 ;
  boolean isValidDebugImage = false ;
  KGLLight light = null ;

  KGLModelData aaa; //Rǂݍ݂ƕ`NXB
//  static float rot = 0.0f ;
  Timer timer = null ;
  timerTask timerT = null ;
  class timerTask extends TimerTask {
	  GLCanvas canvas = null ;
	  float add ;
	  float rot ;
	  timerTask(GLCanvas canvas) {
		  this.canvas = canvas ;
		  add = 2 ;
		  rot = 0.0f ;
	  }
	  public void run() {
		  rot += add;
		  if( rot <= 0 || 360 <= rot  ) {
			  add *= -1 ;
		  }
		  canvas.display() ;
	  }
	  public float getRotate() {
		  return rot ;
	  }
  }
  /*
   * 
   */
  public Test(){
    super("Test");
	  try {
    setSize(400,400);

    // 3D`LoX̐
    GLCanvas can=new GLCanvas();
    can.addGLEventListener(this);
    add(can,BorderLayout.CENTER);
    
    timerT = new timerTask(can) ;
	timer = new Timer() ;
	timer.schedule(timerT,3*1000,100) ;

    // EBhEXi[o^
    addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent ev){
    	if( sm != null ) sm.clear() ;
    	aaa.Clear() ; //\[X
        System.exit(0);
      }
    });
	  } catch(Exception e) {
		  e.printStackTrace() ;
	  }
  }

  /*
   * 
   */
  public void init(GLAutoDrawable dr){
    gl=dr.getGL();
    glu = new GLU() ;
	  try {//MQOt@C̓ǂݍ݁BNX̃CX^X
		  light = new KGLLight(gl,GL.GL_LIGHT0,500.0f,1000.0f,1000.0f,0.8f,0.8f,0.8f) ;

		  aaa = KGLModelData.createGLModel(gl,null,new File(filename),scale,null,true,
				  KGLExtensionCheck.IsExtensionSupported(gl,"GL_ARB_vertex_buffer_object")) ;
//		  aaa = KGLModelData.createGLModel(gl,null,new URL(urlname),scale,null,true,
//				  KGLExtensionCheck.IsExtensionSupported(gl,"GL_ARB_vertex_buffer_object")) ;
		  System.out.println(aaa.toString()) ;
//		  aaa.objectVisible("",false) ;
//		  aaa.materialVisible("",false) ;
			  try {
				  sm = new KGLShadowMapping(gl,glu) ;
				  sm.init(light,0,1,fbow,fboh,0.5f,isValidDebugImage) ;
			  }
			  catch(Exception e) {
				  e.printStackTrace() ;
			  }

	  }
	  catch(Exception e) {
		  e.printStackTrace() ;
	  }
}

  /*
   * `̈ύX
   */
  public void reshape(GLAutoDrawable dr,int x,int y,int w,int h){
//    float r=(float)w/h;                        // c
    gl.glViewport(0,0,w,h);                    // r[|[gϊ
    gl.glMatrixMode(GL.GL_PROJECTION);         // ˉeϊ
    gl.glLoadIdentity();
    double[] projection = new double[16] ;
    gl.glGetDoublev(GL.GL_PROJECTION_MATRIX,projection,0) ;
    glu.gluPerspective(50, (double)w/h, 50, 10000);
//    glu.gluLookAt(0,400,700,0,0,0,0,1,0) ;
    glu.gluLookAt(0,-700,400,0,0,0,0,0,1) ;
 //   gl.glFrustum(-1.0f,1.0f,-r,r,5.0f,400.0f);
    gl.glGetDoublev(GL.GL_PROJECTION_MATRIX,projection,0) ;
 
    if( sm != null ) sm.init_tex_shadowmap();
   }

  /*
   * `
   * 3IuWFNg̕`sB
   */
  public void display(GLAutoDrawable dr){
	  gl.glClearColor(0,0.5f,0,1) ;
      gl.glMatrixMode(GL.GL_MODELVIEW);
      gl.glLoadIdentity();
  gl.glRotatef(90,1,0,0);

//  gl.glScaled(0.5,0.5,0.5) ;
      gl.glTranslatef(-80,-50,200);
  	gl.glPopMatrix() ;

  	float rot = timerT.getRotate() ;
  	if( sm == null ) {
  		drow(rot) ;
  	}
  	else {
	  sm.beforeMakeShadowMap(0,0,0,  50,20,  0,1,0) ;
	  drow(rot) ;
	  sm.afterMakeShadowMap() ;
	  if( sm.getShadowMapImage(true) != 0 ) {
		light.on() ;
		  float floorsize = 100 ;
//		  gl.glActiveTexture( GL.GL_TEXTURE0 );
		  /* */
			gl.glDisable(GL.GL_CULL_FACE);	
			gl.glEnable(GL.GL_TEXTURE_2D) ;
			gl.glBindTexture(GL.GL_TEXTURE_2D,sm.getShadowMapImage(true)) ;
//			gl.glBindTexture(GL.GL_TEXTURE_2D,fbo.getTextureDepth()) ;
			gl.glEnable(GL.GL_DEPTH_TEST) ;
			gl.glEnable(GL.GL_ALPHA_TEST) ;
			gl.glEnable(GL.GL_BLEND) ;
			gl.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_ONE_MINUS_SRC_ALPHA) ;
			gl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
		  gl.glColor3f(0.5f,0.5f,0.5f) ;
		  gl.glNormal3i(0,0,1) ;
		  gl.glBegin(GL.GL_QUADS) ;
		  	gl.glTexCoord2f(0,0) ;gl.glVertex3f(-1.0f*floorsize+250,-1.0f*floorsize+150,20) ;
		  	gl.glTexCoord2f(0,1) ;gl.glVertex3f(-1.0f*floorsize+250, 1.0f*floorsize+150,20) ;
		  	gl.glTexCoord2f(1,1) ;gl.glVertex3f( 1.0f*floorsize+250, 1.0f*floorsize+150,20) ;
		  	gl.glTexCoord2f(1,0) ;gl.glVertex3f( 1.0f*floorsize+250,-1.0f*floorsize+150,20) ;
		  gl.glEnd() ;
	  }
		  sm.beforeDrowSiene() ;
		    gl.glEnable(GL.GL_CULL_FACE);	
		    gl.glCullFace(GL.GL_BACK) ;//ʂ\gȂh
	  drow(rot) ;
	  	sm.afterDrowSiene() ;
  	}

  }
  public void drow(float rotate) {
    gl.glPushMatrix() ;
    //`
	    float floorsize = 400 ;
		gl.glDisable(GL.GL_CULL_FACE);	
		gl.glEnable(GL.GL_DEPTH_TEST) ;
		gl.glEnable(GL.GL_ALPHA_TEST) ;
		gl.glEnable(GL.GL_BLEND) ;
		gl.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_ONE_MINUS_SRC_ALPHA) ;
		gl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
		float[] fw = new float[4] ;
		fw[0] = fw[1] = fw[2] = fw[3] = 1.0f;
	    gl.glColor3f(1.0f,1.0f,1.0f) ;
	    gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_DIFFUSE,fw,0) ;
	    gl.glDisable(GL.GL_TEXTURE_2D) ;
	    gl.glRotatef(rotate,0.0f,1.0f,0.0f) ;
		  gl.glNormal3i(0,1,0) ;
	    gl.glBegin(GL.GL_QUADS) ;
	    	gl.glVertex3f(-1.0f*floorsize,0,-1.0f*floorsize) ;
	    	gl.glVertex3f(-1.0f*floorsize,0, 1.0f*floorsize) ;
	    	gl.glVertex3f( 1.0f*floorsize,0, 1.0f*floorsize) ;
	    	gl.glVertex3f( 1.0f*floorsize,0,-1.0f*floorsize) ;
    	gl.glEnd() ;
    	
    	//f`
		gl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
//		gl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_REPLACE);
		aaa.enables(1.1f) ;
		aaa.draw(1.0f) ;//ǂݍMQOt@C̕`
		aaa.disables() ;
    gl.glPopMatrix() ;
  }
  void printShaderInfoLog(int shader)
  {
    int[] bufSize = new int[1];
    
    gl.glGetShaderiv(shader, GL.GL_INFO_LOG_LENGTH , bufSize,0);
    
    if (bufSize[0] > 1) {
    	IntBuffer ib = IntBuffer.allocate(1) ;
    	ByteBuffer bb = ByteBuffer.allocate(bufSize[0]);
        
        gl.glGetShaderInfoLog(shader, bufSize[0], ib,bb);
        byte[] bdata = bb.array() ;
    	char[] infoLog = new char[bdata.length-1] ;
        for( int i = 0 ; i < infoLog.length ; i++ ) {
        	infoLog[i] = (char)bdata[i] ;
        }
        
        System.out.println(infoLog) ;
    }
  }


  /*
   * fBXvC̕ύX
   */
  public void displayChanged(GLAutoDrawable dr,boolean mc,boolean dc){}

  /**
   ** C
   **/
  public static void main(String[] args){
    (new Test()).setVisible(true);
  }
}
